<?php
/**
 * @package     rsformtobreezingformsconverter
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class RsformprotobreezingformsconverterModelRsformprotobreezingformsconverter extends JModelLegacy
{

    function  __construct($config) {
        parent::__construct($config);

        $option = 'rsformprotobreezingformsconverter';
        $mainframe = JFactory::getApplication();

        // Get pagination request variables
        $limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $limitstart = JRequest::getVar('limitstart', 0, '', 'int');

        // In case limit has been changed, adjust it
        $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

        $this->setState('limit', $limit);
        $this->setState('limitstart', $limitstart);

        $filter_order     = $mainframe->getUserStateFromRequest(  $option.'currencies_filter_order', 'filter_order', 'ordering', 'cmd' );
        $filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'currencies_filter_order_Dir', 'filter_order_Dir', 'asc', 'word' );

        $this->setState('currencies_filter_order', $filter_order);
        $this->setState('currencies_filter_order_Dir', $filter_order_Dir);
    }

    public function clearImportedSubmissions(){
        $cids = JRequest::getVar( 'cid', array(0), 'request', 'array' );
        JArrayHelper::toInteger($cids);
        foreach($cids As $cid)
        {
            $this->_db->setQuery("Select bfformid From #__rsformpro2breezingforms_import Where rsformid = " . $cid . ' Limit 1');
            $bfFormId = $this->_db->loadResult();
            if($bfFormId){
                $this->_db->setQuery("Delete From #__rsformpro2breezingforms_submissions_import Where bfformid = " . $bfFormId);
                $this->_db->query();
            }
        }
    }

    public function clearImportedForm(){
        $cids = JRequest::getVar( 'cid', array(0), 'request', 'array' );
        JArrayHelper::toInteger($cids);
        foreach($cids As $cid)
        {
            $this->_db->setQuery("Select bfformid From #__rsformpro2breezingforms_import Where rsformid = " . $cid . ' Limit 1');
            $bfFormId = $this->_db->loadResult();
            if($bfFormId){
                $this->_db->setQuery("Delete From #__rsformpro2breezingforms_import Where rsformid = " . $cid);
                $this->_db->query();
                $this->_db->setQuery("Delete From #__rsformpro2breezingforms_submissions_import Where bfformid = " . $bfFormId);
                $this->_db->query();
                $this->_db->setQuery("Select id From #__facileforms_records Where form = " . $bfFormId);
                $recordId = $this->_db->loadResult();
                $this->_db->setQuery("Delete From #__facileforms_records Where form = " . $bfFormId);
                $this->_db->query();
                $this->_db->setQuery("Delete From #__facileforms_subrecords Where record = " . $recordId);
                $this->_db->query();
            }
        }
    }

    public function importSubmissions(){
        $cids = JRequest::getVar( 'cid', array(0), 'request', 'array' );
        JArrayHelper::toInteger($cids);
        $imported = 0;
        
        foreach($cids As $cid)
        {
            $this->_db->setQuery("Select bfformid From #__rsformpro2breezingforms_import Where rsformid = " . $cid . ' Limit 1');
            $bfFormId = $this->_db->loadResult();
            if(!$bfFormId){
                return false;
            }

            $this->_db->setQuery("Select * From #__rsform_submissions Where FormId = " . $cid);
            $submissions = $this->_db->loadAssocList();

            foreach($submissions As $submission)
            {
                $this->_db->setQuery("Select count(bfformid) From #__rsformpro2breezingforms_submissions_import Where rssubmissionid = " . $submission['SubmissionId']);
                $exists = $this->_db->loadResult();
                if(!$exists){
                    $this->_db->setQuery("Insert Into #__facileforms_records (form,submitted,ip,username,user_id) Values ($bfFormId,".$this->_db->Quote($submission['DateSubmitted']).",".$this->_db->Quote($submission['UserIp']).",".$this->_db->Quote($submission['Username']).",".$this->_db->Quote($submission['UserId']).")");
                    $this->_db->query();
                    $recordId = $this->_db->insertid();
                    $this->_db->setQuery("Select * From #__rsform_submission_values Where SubmissionId = " . $submission['SubmissionId']);
                    $values = $this->_db->loadAssocList();
                    foreach($values As $value){
                        $this->_db->setQuery("Select id,type,title From #__facileforms_elements Where `form` = $bfFormId And `name` = " . $this->_db->Quote($value['FieldName']));
                        $elements = $this->_db->loadAssocList();
                        foreach($elements As $element){
                            $this->_db->setQuery("Insert Into #__facileforms_subrecords (record,element,title,`name`,type,`value`) Values ($recordId,".$element['id'].",".$this->_db->Quote($element['title']).",".$this->_db->Quote($value['FieldName']).",".$this->_db->Quote($element['type']).",".$this->_db->Quote($value['FieldValue']).")");
                            $this->_db->query();
                        }
                    }
                    $this->_db->setQuery("Insert Into #__rsformpro2breezingforms_submissions_import (bfformid,rssubmissionid) Values ($bfFormId,".$submission['SubmissionId'].")");
                    $this->_db->query();
                    $imported++;
                }
            }
        }

        return 'Imported ' . $imported . ' submissions!';
    }

    public function import()
    {
        $log = '';

        $cids = JRequest::getVar( 'cid', array(0), 'request', 'array' );
        JArrayHelper::toInteger($cids);

        require_once(JPATH_SITE . '/administrator/components/com_breezingforms/admin/quickmode.class.php');
        require_once(JPATH_SITE . '/administrator/components/com_breezingforms/libraries/Zend/Json/Decoder.php');
        require_once(JPATH_SITE . '/administrator/components/com_breezingforms/libraries/Zend/Json/Encoder.php');

        foreach($cids As $cid)
        {
            $this->_db->setQuery("Select bfformid From #__rsformpro2breezingforms_import Where rsformid = " . $cid . ' Limit 1');
            $bfFormId = $this->_db->loadResult();
            if($bfFormId){
                return false;
            }

            $this->_db->setQuery("Select * From #__rsform_forms Where `FormId` = " . $cid);
            $headData = $this->_db->loadAssocList();
            $root = '{"attributes": {"class": "bfQuickModeRootClass", "id": "bfQuickModeRoot", "mdata": "{\"type\": \"root\"}"}, "properties": {"type": "root", "title": "MyFormTitle", "name": "MyFormName", "rollover": true, "rolloverColor": "#ffc", "toggleFields": "", "description": "", "mailNotification": "", "mailRecipient": "", "submitInclude": true, "submitLabel": "submit", "cancelInclude": false, "cancelLabel": "reset", "pagingInclude": true, "pagingNextLabel": "next", "pagingPrevLabel": "back", "theme": "default", "fadeIn": false, "lastPageThankYou": false, "submittedScriptCondidtion": 0, "submittedScriptCode": "", "useErrorAlerts": false, "useDefaultErrors": true, "useBalloonErrors": false}, "state": "open", "data": {"title": "MyFormTitle", "icon": "../administrator/components/com_breezingforms/libraries/jquery/themes/quickmode/i/icon_form.png"}, "children": [{"attributes": {"class": "bfQuickModePageClass", "id": "bfQuickModePage1", "mdata": "{\"deletable\": true, \"type\": \"page\"}"}, "properties": {"type": "page", "pageNumber": 1, "pageIntro": ""}, "state": "open", "data": {"title": "Page 1", "icon": "../administrator/components/com_breezingforms/libraries/jquery/themes/quickmode/i/icon_page.png"}, "children": []}]}';
            $form = Zend_Json::decode($root);
            $elements = array();
            $head = array();
            $userMails = array();
            
            foreach($headData As $head){
                $log .= 'Log for form: ' . $head['FormTitle']."\n<br/>========================<br/>\n";
                $form['properties']['title'] = $head['FormTitle'];
                $form['data']['title'] = $head['FormTitle'];
                $form['properties']['name'] = preg_replace("/[^a-zA-Z0-9_]/", "", $head['FormName']);

                if(trim($head['Thankyou']) != ''){
                    $thankyoupage = '{"attributes": {"class": "bfQuickModePageClass", "id": "bfQuickModePage2", "mdata": "{\"deletable\": true, \"type\": \"page\"}"}, "properties": {"type": "page", "pageNumber": 2, "pageIntro": ""}, "state": "open", "data": {"title": "Page 2", "icon": "../administrator/components/com_breezingforms/libraries/jquery/themes/quickmode/i/icon_page.png"}, "children": []}';
                    $thankyoupage = Zend_Json::decode($thankyoupage);
                    $thankyoupage['properties']['pageIntro'] = trim($head['Thankyou']);
                    $form['children'][] = $thankyoupage;
                    $form['properties']['lastPageThankYou'] = true;
                }

                $userEmailPlaceholders = '';
                if(trim($head['UserEmailTo'])){
                    $userEmailPlaceholders = explode(',',trim($head['UserEmailTo']));
                    foreach($userEmailPlaceholders As $userEmailPlaceholder){
                        $placeholder = explode(':',$userEmailPlaceholder);
                        if(count($placeholder) == 2){
                            $holder = trim(ltrim($placeholder[0], '{'));
                            $userMails[$holder] = true;
                        }
                        else{
                            $log .= '- User Email to defined but it is no placeholder, you might need to adjust that in BreezingForms'."\n<br/>\n";
                        }
                    }
                }
                if(trim($head['UserEmailCC'])){
                    $userEmailPlaceholders = explode(',',trim($head['UserEmailCC']));
                    foreach($userEmailPlaceholders As $userEmailPlaceholder){
                        $placeholder = explode(':',$userEmailPlaceholder);
                        if(count($placeholder) == 2){
                            $holder = trim(ltrim($placeholder[0], '{'));
                            $userMails[$holder] = true;
                        }
                        else{
                            $log .= '- User Email CC defined but it is no placeholder, you might need to adjust that in BreezingForms'."\n<br/>\n";
                        }
                    }
                }
                if(trim($head['UserEmailBCC'])){
                    $userEmailPlaceholders = explode(',',trim($head['UserEmailBCC']));
                    foreach($userEmailPlaceholders As $userEmailPlaceholder){
                        $placeholder = explode(':',$userEmailPlaceholder);
                        if(count($placeholder) == 2){
                            $holder = trim(ltrim($placeholder[0], '{'));
                            $userMails[$holder] = true;
                        }
                        else{
                            $log .= '- User Email BCC defined but it is no placeholder, you might need to adjust that in BreezingForms'."\n<br/>\n";
                        }
                    }
                }
                
                $this->_db->setQuery("Select Distinct `properties`.*, `components`.`ComponentId`, `types`.`ComponentTypeName` From #__rsform_forms As `forms`, #__rsform_components As `components`, #__rsform_component_types As `types`, #__rsform_properties As `properties` Where `properties`.`ComponentId` = `components`.`ComponentId` And `types`.`ComponentTypeId` = `components`.`ComponentTypeId` And `components`.`FormId` = `forms`.`FormId` And `forms`.`FormId` = " . $cid . " Order by `components`.`Order`,`properties`.`PropertyName`");
                $properties = $this->_db->loadAssocList();
                foreach($properties As $property){
                    $elements[$property['ComponentId']][] = $property;
                }
            }

            foreach($elements As $element){
                if(isset($element[0]) && isset($element[0]['ComponentTypeName'])){
                    switch( $element[0]['ComponentTypeName'] ){
                        case 'textBox':
                        case 'textArea':
                        case 'password':
                        case 'hidden':
                            mt_srand();
                            $text = '{"attributes": {"class": "bfQuickModeElementClass", "id": "bfQuickMode'.mt_rand(0,mt_getrandmax()).'", "mdata": "{\"deletable\": true, \"type\": \"element\"}"}, "data": {"title": "mytextfield", "icon": "../administrator/components/com_breezingforms/libraries/jquery/themes/quickmode/i/icon_text-field.png"}, "properties": {"type": "element", "bfType": "bfTextfield", "label": "mytextfield", "labelPosition": "left", "bfName": "mytextfield", "dbId": 0, "orderNumber": "-1", "tabIndex": "-1", "logging": true, "hideLabel": false, "required": false, "hint": "", "off": false, "value": "", "maxLength": "", "readonly": false, "password": false, "mailback": false, "mailbackAsSender": false, "mailbackfile": "", "size": "", "validationCondition": 0, "validationId": "0", "validationCode": "", "validationMessage": "", "validationFunctionName": "", "initCondition": 0, "initId": "0", "initCode": "", "initFunctionName": "", "initFormEntry": 0, "initPageEntry": 0, "actionCondition": 0, "actionId": "0", "actionCode": "", "actionFunctionName": "", "actionClick": 0, "actionBlur": 0, "actionChange": 0, "actionFocus": 0, "actionSelect": 0, "hideInMailback": false}}';
                            if($element[0]['ComponentTypeName'] == 'textArea'){
                                $text = '{"attributes": {"class": "bfQuickModeElementClass", "id": "bfQuickMode'.mt_rand(0,mt_getrandmax()).'", "mdata": "{\"deletable\": true, \"type\": \"element\"}"}, "data": {"title": "untitled element", "icon": "../administrator/components/com_breezingforms/libraries/jquery/themes/quickmode/i/icon_text-area.png"}, "properties": {"type": "element", "bfType": "bfTextarea", "label": "untitled element", "labelPosition": "left", "bfName": "mytextarea", "dbId": 0, "orderNumber": "-1", "tabIndex": "-1", "logging": true, "hideLabel": false, "required": false, "hint": "", "off": false, "value": "", "width": "", "height": "", "maxlength": "0", "showMaxlengthCounter": true, "readonly": false, "validationCondition": 0, "validationId": "0", "validationCode": "", "validationMessage": "", "validationFunctionName": "", "initCondition": 0, "initId": "0", "initCode": "", "initFunctionName": "", "initFormEntry": 0, "initPageEntry": 0, "actionCondition": 0, "actionId": "0", "actionCode": "", "actionFunctionName": "", "actionClick": 0, "actionBlur": 0, "actionChange": 0, "actionFocus": 0, "actionSelect": 0, "hideInMailback": false}}';
                            }
                            if($element[0]['ComponentTypeName'] == 'hidden'){
                                $text = '{"attributes": {"class": "bfQuickModeElementClass", "id": "bfQuickMode'.mt_rand(0,mt_getrandmax()).'", "mdata": "{\"deletable\": true, \"type\": \"element\"}"}, "data": {"title": "untitled element", "icon": "../administrator/components/com_breezingforms/libraries/jquery/themes/quickmode/i/icon_hidden-input.png"}, "properties": {"type": "element", "bfType": "bfHidden", "label": "untitled element", "labelPosition": "left", "bfName": "myhidden", "dbId": 0, "orderNumber": -1, "tabIndex": -1, "logging": true, "hideLabel": true, "required": false, "hint": "", "off": false, "readonly": false, "value": "", "validationCondition": 0, "validationId": 0, "validationCode": "", "validationMessage": "", "validationFunctionName": "", "initCondition": 0, "initId": 0, "initCode": "", "initFunctionName": "", "initFormEntry": 0, "initPageEntry": 0, "actionCondition": 0, "actionId": 0, "actionCode": "", "actionFunctionName": "", "actionClick": 0, "actionBlur": 0, "actionChange": 0, "actionFocus": 0, "actionSelect": 0, "hideInMailback": false}}';
                            }
                            
                            $text = Zend_Json::decode($text);
                            if($element[0]['ComponentTypeName'] == 'password'){
                                $text['properties']['password'] = true;
                            }
                            foreach($element As $prop){
                                switch($prop['PropertyName']){
                                    case 'NAME':
                                        $text['properties']['bfName'] = preg_replace("/[^a-zA-Z0-9_]/", "", $prop['PropertyValue']);
                                        if($element[0]['ComponentTypeName'] == 'textBox' && isset($userMails[$prop['PropertyValue']])){
                                            $text['properties']['mailback'] = true;
                                        }
                                        if($element[0]['ComponentTypeName'] == 'textBox' && intval($head['UserEmailAttach']) == 1){
                                            $text['properties']['mailbackfile'] = trim($head['UserEmailAttachFile']);
                                        }
                                        break;
                                    case 'CAPTION':
                                        $text['data']['title']       = $prop['PropertyValue'];
                                        $text['properties']['label'] = $prop['PropertyValue'];
                                        break;
                                    case 'DESCRIPTION':
                                        $text['properties']['hint'] = $prop['PropertyValue'];
                                        break;
                                    case 'DEFAULTVALUE':
                                        if(strpos(trim($prop['PropertyValue']), '//<code>') === 0){
                                            $log .= '- Default Value code recognized for element "'.$select['properties']['bfName'].'", you will probably need to adjust it in BreezingForms'."\n<br/>\n";
                                        }
                                        $text['properties']['value'] = str_replace(array('//<code>','//</code>'),array('<?php ',' ?>'),$prop['PropertyValue']);
                                        break;
                                    case 'VALIDATIONRULE':
                                        switch($prop['PropertyValue']){
                                            case 'email':
                                                $text['properties']['validationId'] = $this->getValidationId('ff_validemail');
                                                $text['properties']['validationCondition'] = 1;
                                                $text['properties']['validationFunctionName'] = 'ff_validemail';
                                                break;
                                            case 'numeric':
                                                $text['properties']['validationId'] = 0;
                                                $text['properties']['validationCondition'] = 2;
                                                $text['properties']['validationFunctionName'] = 'ff_' . $text['properties']['bfName'] . '_validation';
                                                $text['properties']['validationCode'] = 'function ff_' . $text['properties']['bfName'] . '_validation(element, message){'."\n".'if (isNaN(element.value)) {'."\n".'if (message=="") message = element.name+" faild in my test.\n"'."\n".'ff_validationFocus(element.name);'."\n".'return message;'."\n".'}'."\n".'return "";'."\n".'}';
                                                break;
                                            case 'alphanumeric':
                                                $text['properties']['validationId'] = 0;
                                                $text['properties']['validationCondition'] = 2;
                                                $text['properties']['validationFunctionName'] = 'ff_' . $text['properties']['bfName'] . '_validation';
                                                $text['properties']['validationCode'] = 'function ff_' . $text['properties']['bfName'] . '_validation(element, message){'."\n".'var re = /^[A-Za-z0-9]+$/;'."\n".'if (!re.test(element.value)) {'."\n".'if (message=="") message = element.name+" faild in my test.\n"'."\n".'ff_validationFocus(element.name);'."\n".'return message;'."\n".'}'."\n".'return "";'."\n".'}';
                                                break;
                                            case 'alpha':
                                                $text['properties']['validationId'] = 0;
                                                $text['properties']['validationCondition'] = 2;
                                                $text['properties']['validationFunctionName'] = 'ff_' . $text['properties']['bfName'] . '_validation';
                                                $text['properties']['validationCode'] = 'function ff_' . $text['properties']['bfName'] . '_validation(element, message){'."\n".'var re = /^[A-Za-z]+$/;'."\n".'if (!re.test(element.value)) {'."\n".'if (message=="") message = element.name+" faild in my test.\n"'."\n".'ff_validationFocus(element.name);'."\n".'return message;'."\n".'}'."\n".'return "";'."\n".'}';
                                                break;
                                            default:
                                                if($prop['PropertyValue'] != 'none' && $prop['PropertyValue'] != 'password'){
                                                    $log .= '- Unimported validation rule for element "' . $text['properties']['bfName'] . '" detected: "' . $prop['PropertyValue'] . '"' . "\n<br/>\n";
                                                }
                                                break;
                                        }
                                        break;
                                    case 'VALIDATIONMESSAGE':
                                        $text['properties']['validationMessage'] = $prop['PropertyValue'];
                                        break;
                                    case 'REQUIRED':
                                        $text['properties']['required'] = $prop['PropertyValue'] == 'YES' ? true : false;
                                        $text['properties']['validationId'] = $this->getValidationId('ff_valuenotempty');
                                        $text['properties']['validationCondition'] = 1;
                                        $text['properties']['validationFunctionName'] = 'ff_valuenotempty';
                                        break;
                                    case 'ADDITIONALATTRIBUTES':
                                        $log .= trim($prop['PropertyValue']) != '' ? 'Use of additional attributes detected "'.htmlentities($prop['PropertyValue'],ENT_QUOTES,'UTF-8').'". You might need to adjust in BreezingForms if you use Javascript there.'."\n<br/>\n" : '';
                                        break;
                                }
                            }
                            $form['children'][0]['children'][] = $text;
                            break;
                        case 'paypalTotal':
                            $text = '{"attributes": {"class": "bfQuickModeElementClass", "id": "bfQuickMode'.mt_rand(0,mt_getrandmax()).'", "mdata": "{\"deletable\": true, \"type\": \"element\"}"}, "data": {"title": "mytextfield", "icon": "../administrator/components/com_breezingforms/libraries/jquery/themes/quickmode/i/icon_text-field.png"}, "properties": {"type": "element", "bfType": "bfTextfield", "label": "mytextfield", "labelPosition": "left", "bfName": "PayPalTotal", "dbId": 0, "orderNumber": "-1", "tabIndex": "-1", "logging": true, "hideLabel": false, "required": false, "hint": "", "off": false, "value": "", "maxLength": "", "readonly": false, "password": false, "mailback": false, "mailbackAsSender": false, "mailbackfile": "", "size": "", "validationCondition": 0, "validationId": "0", "validationCode": "", "validationMessage": "", "validationFunctionName": "", "initCondition": 0, "initId": "0", "initCode": "", "initFunctionName": "", "initFormEntry": 0, "initPageEntry": 0, "actionCondition": 0, "actionId": "0", "actionCode": "", "actionFunctionName": "", "actionClick": 0, "actionBlur": 0, "actionChange": 0, "actionFocus": 0, "actionSelect": 0, "hideInMailback": false}}';
                            $text = Zend_Json::decode($text);
                            foreach($element As $prop){
                                switch($prop['PropertyName']){
                                    case 'CAPTION':
                                        $text['data']['title']       = $prop['PropertyValue'];
                                        $text['properties']['label'] = $prop['PropertyValue'];
                                        break;
                                }
                            }
                            $text['properties']['readonly'] = true;
                            $form['children'][0]['children'][] = $text;
                            break;
                        case 'paypalMultipleProducts':

                            $this->_db->setQuery("Select `SettingValue` From #__rsform_config Where `SettingName` = 'paypal.nodecimals'");
                            $numDecimals = $this->_db->loadResult();
                            $this->_db->setQuery("Select `SettingValue` From #__rsform_config Where `SettingName` = 'paypal.decimal'");
                            $decimal = $this->_db->loadResult();
                            $this->_db->setQuery("Select `SettingValue` From #__rsform_config Where `SettingName` = 'paypal.thousands'");
                            $thousands = $this->_db->loadResult();

                            $this->_db->setQuery("Select `SettingValue` From #__rsform_config Where `SettingName` = 'paypal.currency'");
                            $currency = $this->_db->loadResult();
                            $this->_db->setQuery("Select `SettingValue` From #__rsform_config Where `SettingName` = 'paypal.test'");
                            $test = $this->_db->loadResult();
                            $this->_db->setQuery("Select `SettingValue` From #__rsform_config Where `SettingName` = 'paypal.email'");
                            $business = $this->_db->loadResult();
                            
                            mt_srand();
                            $hidden = '{"attributes": {"class": "bfQuickModeElementClass", "id": "bfQuickMode'.mt_rand(0,mt_getrandmax()).'", "mdata": "{\"deletable\": true, \"type\": \"element\"}"}, "data": {"title": "untitled element", "icon": "../administrator/components/com_breezingforms/libraries/jquery/themes/quickmode/i/icon_hidden-input.png"}, "properties": {"type": "element", "bfType": "bfHidden", "label": "untitled element", "labelPosition": "left", "bfName": "PayPalSelect", "dbId": 0, "orderNumber": -1, "tabIndex": -1, "logging": true, "hideLabel": true, "required": false, "hint": "", "off": false, "readonly": false, "value": "", "validationCondition": 0, "validationId": 0, "validationCode": "", "validationMessage": "", "validationFunctionName": "", "initCondition": 0, "initId": 0, "initCode": "", "initFunctionName": "", "initFormEntry": 0, "initPageEntry": 0, "actionCondition": 0, "actionId": 0, "actionCode": "", "actionFunctionName": "", "actionClick": 0, "actionBlur": 0, "actionChange": 0, "actionFocus": 0, "actionSelect": 0, "hideInMailback": false}}';
                            $hidden = Zend_Json::decode($hidden);
                            $select = '{"attributes": {"class": "bfQuickModeElementClass", "id": "bfQuickMode'.mt_rand(0,mt_getrandmax()).'", "mdata": "{\"deletable\": true, \"type\": \"element\"}"}, "data": {"title": "untitled element", "icon": "../administrator/components/com_breezingforms/libraries/jquery/themes/quickmode/i/icon_select.png"}, "properties": {"type": "element", "bfType": "bfSelect", "label": "untitled element", "labelPosition": "left", "bfName": "PayPalSelect", "dbId": 0, "orderNumber": -1, "tabIndex": -1, "logging": true, "hideLabel": false, "required": false, "hint": "", "off": false, "list": "0;Title 1;value1\n0;Title 2;value2\n0;Title 3;value3", "readonly": false, "multiple": false, "mailback": false, "width": "", "height": "", "validationCondition": 0, "validationId": 0, "validationCode": "", "validationMessage": "", "validationFunctionName": "", "initCondition": 0, "initId": 0, "initCode": "", "initFunctionName": "", "initFormEntry": 0, "initPageEntry": 0, "actionCondition": 0, "actionId": 0, "actionCode": "", "actionFunctionName": "", "actionClick": 0, "actionBlur": 0, "actionChange": 0, "actionFocus": 0, "actionSelect": 0, "hideInMailback": false}}';
                            $select = Zend_Json::decode($select);
                            $pal = '{"attributes": {"class": "bfQuickModeElementClass", "id": "bfQuickMode'.mt_rand(0,mt_getrandmax()).'", "mdata": "{\"deletable\": true, \"type\": \"element\"}"}, "data": {"title": "untitled element", "icon": "../administrator/components/com_breezingforms/libraries/jquery/themes/quickmode/i/icon_paypal.png"}, "properties": {"type": "element", "bfType": "bfPayPal", "label": "untitled element", "labelPosition": "left", "bfName": "mypaypalbutton", "dbId": 0, "orderNumber": -1, "tabIndex": -1, "logging": true, "hideLabel": false, "required": false, "hint": "", "off": false, "readonly": false, "testaccount": false, "downloadableFile": false, "filepath": "", "downloadTries": 1, "business": "", "token": "", "testBusiness": "", "testToken": "", "itemname": "", "itemnumber": "", "amount": "", "tax": "", "thankYouPage": "", "locale": "us", "currencyCode": "USD", "image": "http://www.paypal.com/en_US/i/btn/btn_paynowCC_LG.gif", "sendNotificationAfterPayment": false, "useIpn": false, "validationCondition": 0, "validationId": 0, "validationCode": "", "validationMessage": "", "validationFunctionName": "", "initCondition": 0, "initId": 0, "initCode": "", "initFunctionName": "", "initFormEntry": 0, "initPageEntry": 0, "actionCondition": 0, "actionId": 0, "actionCode": "", "actionFunctionName": "ff_validate_submit", "actionClick": 1, "actionBlur": 0, "actionChange": 0, "actionFocus": 0, "actionSelect": 0, "hideInMailback": false}}';
                            $pal = Zend_Json::decode($pal);
                            
                            foreach($element As $prop){
                                switch($prop['PropertyName']){
                                    case 'NAME':
                                        $select['properties']['bfName'] = preg_replace("/[^a-zA-Z0-9_]/", "", $prop['PropertyValue']);
                                        $pal['properties']['bfName'] = preg_replace("/[^a-zA-Z0-9_]/", "", $prop['PropertyValue']).'_paypalbutton';
                                        break;
                                    case 'CAPTION':
                                        $select['data']['title']       = $prop['PropertyValue'];
                                        $select['properties']['label'] = $prop['PropertyValue'];
                                        $pal['data']['title']          = $prop['PropertyValue'];
                                        $pal['properties']['label']    = $prop['PropertyValue'];
                                        break;
                                    case 'DESCRIPTION':
                                        $select['properties']['hint'] = $prop['PropertyValue'];
                                        break;
                                    case 'VALIDATIONMESSAGE':
                                        $select['properties']['validationMessage'] = $prop['PropertyValue'];
                                        break;
                                    case 'MULTIPLE':
                                        $select['properties']['multiple'] = $prop['PropertyValue'] == 'YES' ? true : false;
                                        break;
                                    case 'REQUIRED':
                                        $select['properties']['required'] = $prop['PropertyValue'] == 'YES' ? true : false;
                                        if($select['properties']['required']){
                                            $select['properties']['validationId'] = $this->getValidationId('ff_valuenotempty');
                                            $select['properties']['validationCondition'] = 1;
                                            $select['properties']['validationFunctionName'] = 'ff_valuenotempty';
                                        }
                                        break;
                                    case 'ITEMS':
                                        if(strpos(trim($prop['PropertyValue']), '//<code>') === 0){
                                            $select['properties']['list'] = str_replace(array('//<code>','//</code>'),array('<?php ',' ?>'),$prop['PropertyValue']);
                                            $log .= '- Items code recognized for element "'.$select['properties']['bfName'].'", you will probably need to adjust it in BreezingForms'."\n<br/>\n";
                                        }else{
                                            $sel = '';
                                            $items = explode("\n",str_replace("\r","",$prop['PropertyValue']));
                                            foreach($items As $item){
                                                // test if advanced exists
                                                $value = '';
                                                $label = '';
                                                $advanced = explode("|", $item);
                                                if(count($advanced) == 2){
                                                    $label = $advanced[1];
                                                    $value = $advanced[0];
                                                }else{
                                                    $label = $advanced[0];
                                                    $value = $advanced[0];
                                                }
                                                
                                                $sel .= '0;' . ( is_numeric($value) ? ( $label != $value ? $label . ' - ' : '') . number_format($value,$numDecimals,$decimal,$thousands) . ' ' . $currency : $label ) . ';' . (is_numeric($value) ? $value : '') . "\n";
                                            }
                                            $sel = trim($sel);
                                            $select['properties']['list'] = $sel;
                                        }
                                        break;
                                    case 'ADDITIONALATTRIBUTES':
                                        $log .= trim($prop['PropertyValue']) != '' ? '- Use of additional attributes detected "'.htmlentities($prop['PropertyValue'],ENT_QUOTES,'UTF-8').'". You might need to adjust in BreezingForms if you use Javascript there.'."\n<br/>\n" : '';
                                        break;
                                }
                            }

                            $select['properties']['actionId'] = 0;
                            $select['properties']['actionCondition'] = 2;
                            $select['properties']['actionFunctionName'] = 'ff_' . $select['properties']['bfName'] . '_action';
                            $select['properties']['actionCode'] = 'function ff_' . $select['properties']['bfName'] . '_action(element, action){
                                switch (action) {
                                    case "change":
                                        var selected = ff_selectedValues("'.$select['properties']['bfName'].'").split(",");
                                        var newPrice = 0;
                                        for(var i = 0; i < selected.length;i++){
                                             if(!isNaN(selected[i])){
                                                newPrice += Number(selected[i]);
                                            }
                                        }
                                        ff_getElementByName("PayPalSelect").value = "'.addslashes($select['data']['title']).'|1|"+newPrice+"|0";
                                        if( typeof ff_getElementByName("PayPalTotal") != "undefined" ){
                                            ff_getElementByName("PayPalTotal").value = number_format(newPrice,'.intval($numDecimals).',"'.$decimal.'","'.$thousands.'");
                                        }
                                        break;
                                    default:;
                                }
                            }

                            function number_format(n,s,d,t){
                                n=n.toFixed(s);
                                z=n.split(\'.\');
                                g=z[0].split(\'\').reverse();
                                g=g.join(\'\');
                                s=\'\';
                                for (var i=1;i<=g.length;i++){
                                s+=g.charAt(i-1);
                                if(i%3==0&&i!=g.length)s+=t;
                                }
                                g=s.split(\'\').reverse();
                                de=\'\';
                                if(z[1])de=d+z[1];
                                g=g.join(\'\')+de;
                                return g;
                            }
                            ';
                            $select['properties']['actionChange'] = 1;

                            $pal['properties']['business'] = $business;
                            $pal['properties']['testBusiness'] = $business;
                            $pal['properties']['currencyCode'] = $currency;
                            $pal['properties']['testaccount'] = $test == 0 ? true : false;

                            $pal['properties']['actionId'] = $this->getValidationId('ff_validate_submit');
                            $pal['properties']['actionCondition'] = 1;
                            $pal['properties']['actionClick'] = 1;
                            $pal['properties']['actionFunctionName'] = 'ff_validate_submit';

                            $form['properties']['submitInclude'] = false;

                            $form['children'][0]['children'][] = $select;
                            $form['children'][0]['children'][] = $pal;
                            $form['children'][0]['children'][] = $hidden;
                            break;
                        case 'paypalSingleProduct':
                            mt_srand();
                            $showPrice = false;
                            $pal = '{"attributes": {"class": "bfQuickModeElementClass", "id": "bfQuickMode'.mt_rand(0,mt_getrandmax()).'", "mdata": "{\"deletable\": true, \"type\": \"element\"}"}, "data": {"title": "untitled element", "icon": "../administrator/components/com_breezingforms/libraries/jquery/themes/quickmode/i/icon_paypal.png"}, "properties": {"type": "element", "bfType": "bfPayPal", "label": "untitled element", "labelPosition": "left", "bfName": "mypaypalbutton", "dbId": 0, "orderNumber": -1, "tabIndex": -1, "logging": true, "hideLabel": false, "required": false, "hint": "", "off": false, "readonly": false, "testaccount": false, "downloadableFile": false, "filepath": "", "downloadTries": 1, "business": "", "token": "", "testBusiness": "", "testToken": "", "itemname": "", "itemnumber": "", "amount": "", "tax": "", "thankYouPage": "", "locale": "us", "currencyCode": "USD", "image": "http://www.paypal.com/en_US/i/btn/btn_paynowCC_LG.gif", "sendNotificationAfterPayment": false, "useIpn": false, "validationCondition": 0, "validationId": 0, "validationCode": "", "validationMessage": "", "validationFunctionName": "", "initCondition": 0, "initId": 0, "initCode": "", "initFunctionName": "", "initFormEntry": 0, "initPageEntry": 0, "actionCondition": 0, "actionId": 0, "actionCode": "", "actionFunctionName": "ff_validate_submit", "actionClick": 1, "actionBlur": 0, "actionChange": 0, "actionFocus": 0, "actionSelect": 0, "hideInMailback": false}}';
                            $pal = Zend_Json::decode($pal);
                            foreach($element As $prop){
                                switch($prop['PropertyName']){
                                    case 'NAME':
                                        $pal['properties']['bfName'] = preg_replace("/[^a-zA-Z0-9_]/", "", $prop['PropertyValue']);
                                        break;
                                    case 'CAPTION':
                                        $pal['data']['title']       = $prop['PropertyValue'];
                                        $pal['properties']['label'] = $prop['PropertyValue'];
                                        break;
                                    case 'DESCRIPTION':
                                        $pal['properties']['hint'] = $prop['PropertyValue'];
                                        break;
                                    case 'PRICE':
                                        $pal['properties']['amount'] = $prop['PropertyValue'];
                                        $pal['properties']['itemname'] = $pal['data']['title'];
                                        $pal['properties']['itemnumber'] = 1;
                                        $pal['properties']['tex'] = 0;
                                        break;
                                    case 'SHOW':
                                        $showPrice = $prop['PropertyValue'] == 'YES' ? true : false;
                                        break;
                                }
                            }
                            
                            $this->_db->setQuery("Select `SettingValue` From #__rsform_config Where `SettingName` = 'paypal.currency'");
                            $currency = $this->_db->loadResult();
                            $pal['properties']['currencyCode'] = $currency;
                            $this->_db->setQuery("Select `SettingValue` From #__rsform_config Where `SettingName` = 'paypal.test'");
                            $test = $this->_db->loadResult();
                            $pal['properties']['testaccount'] = $test == 0 ? true : false;
                            $this->_db->setQuery("Select `SettingValue` From #__rsform_config Where `SettingName` = 'paypal.email'");
                            $business = $this->_db->loadResult();
                            $pal['properties']['business'] = $business;
                            $pal['properties']['testBusiness'] = $business;

                            if($showPrice){
                                $this->_db->setQuery("Select `SettingValue` From #__rsform_config Where `SettingName` = 'paypal.nodecimals'");
                                $numDecimals = $this->_db->loadResult();
                                $this->_db->setQuery("Select `SettingValue` From #__rsform_config Where `SettingName` = 'paypal.decimal'");
                                $decimal = $this->_db->loadResult();
                                $this->_db->setQuery("Select `SettingValue` From #__rsform_config Where `SettingName` = 'paypal.thousands'");
                                $thousands = $this->_db->loadResult();
                                $pal['properties']['label'] = $pal['properties']['label'] . ' - ' . number_format($pal['properties']['amount'],$numDecimals,$decimal,$thousands);
                                $pal['data']['title'] = $pal['properties']['label'];
                            }

                            $pal['properties']['actionId'] = $this->getValidationId('ff_validate_submit');
                            $pal['properties']['actionCondition'] = 1;
                            $pal['properties']['actionClick'] = 1;
                            $pal['properties']['actionFunctionName'] = 'ff_validate_submit';

                            $form['properties']['submitInclude'] = false;
                            $form['children'][0]['children'][] = $pal;

                            $log .= '- Single PayPal product detected, you might have to add the paypal token if the button doesn\'t work for you.'."\n<br/>\n";
                            break;
                        case 'captcha':
                        case 'recaptcha':
                            mt_srand();
                            $cap = '{"attributes": {"class": "bfQuickModeElementClass", "id": "bfQuickMode'.mt_rand(0,mt_getrandmax()).'", "mdata": "{\"deletable\": true, \"type\": \"element\"}"}, "data": {"title": "untitled element", "icon": "../administrator/components/com_breezingforms/libraries/jquery/themes/quickmode/i/icon_captcha.png"}, "properties": {"type": "element", "bfType": "bfCaptcha", "label": "untitled element", "labelPosition": "left", "bfName": "mycaptcha", "dbId": 0, "orderNumber": -1, "tabIndex": -1, "logging": false, "hideLabel": false, "required": false, "hint": "", "off": false, "readonly": false, "validationCondition": 0, "validationId": 0, "validationCode": "", "validationMessage": "", "validationFunctionName": "", "initCondition": 0, "initId": 0, "initCode": "", "initFunctionName": "", "initFormEntry": 0, "initPageEntry": 0, "actionCondition": 0, "actionId": 0, "actionCode": "", "actionFunctionName": "", "actionClick": 0, "actionBlur": 0, "actionChange": 0, "actionFocus": 0, "actionSelect": 0, "hideInMailback": false}}';
                            if($element[0]['ComponentTypeName'] == 'recaptcha'){
                                $cap = '{"attributes": {"class": "bfQuickModeElementClass", "id": "bfQuickMode'.mt_rand(0,mt_getrandmax()).'", "mdata": "{\"deletable\": true, \"type\": \"element\"}"}, "data": {"title": "untitled element", "icon": "../administrator/components/com_breezingforms/libraries/jquery/themes/quickmode/i/icon_captcha.png"}, "properties": {"type": "element", "bfType": "bfReCaptcha", "label": "untitled element", "labelPosition": "left", "bfName": "myrecaptcha", "dbId": 0, "orderNumber": -1, "tabIndex": -1, "logging": false, "hideLabel": false, "required": false, "hint": "", "off": false, "readonly": false, "pubkey": "", "privkey": "", "theme": "red", "validationCondition": 0, "validationId": 0, "validationCode": "", "validationMessage": "", "validationFunctionName": "", "initCondition": 0, "initId": 0, "initCode": "", "initFunctionName": "", "initFormEntry": 0, "initPageEntry": 0, "actionCondition": 0, "actionId": 0, "actionCode": "", "actionFunctionName": "", "actionClick": 0, "actionBlur": 0, "actionChange": 0, "actionFocus": 0, "actionSelect": 0, "hideInMailback": false}}';
                            }
                            $cap = Zend_Json::decode($cap);
                            foreach($element As $prop){
                                switch($prop['PropertyName']){
                                    case 'NAME':
                                        $cap['properties']['bfName'] = preg_replace("/[^a-zA-Z0-9_]/", "", $prop['PropertyValue']);
                                        break;
                                    case 'CAPTION':
                                        $cap['data']['title']       = $prop['PropertyValue'];
                                        $cap['properties']['label'] = $prop['PropertyValue'];
                                        break;
                                    case 'DESCRIPTION':
                                        $cap['properties']['hint'] = $prop['PropertyValue'];
                                        break;
                                    case 'ADDITIONALATTRIBUTES':
                                        $log .= trim($prop['PropertyValue']) != '' ? '- Use of additional attributes detected "'.htmlentities($prop['PropertyValue'],ENT_QUOTES,'UTF-8').'". You might need to adjust in BreezingForms if you use Javascript there.'."\n<br/>\n" : '';
                                        break;
                                }
                            }
                            if($element[0]['ComponentTypeName'] == 'recaptcha'){
                                $this->_db->setQuery("Select `SettingValue` From #__rsform_config Where `SettingName` = 'recaptcha.private.key'");
                                $privKey = $this->_db->loadResult();
                                $this->_db->setQuery("Select `SettingValue` From #__rsform_config Where `SettingName` = 'recaptcha.public.key'");
                                $pubKey = $this->_db->loadResult();
                                $this->_db->setQuery("Select `SettingValue` From #__rsform_config Where `SettingName` = 'recaptcha.theme'");
                                $theme = $this->_db->loadResult();
                                $cap['properties']['pubkey'] = $pubKey;
                                $cap['properties']['privkey'] = $privKey;
                                $cap['properties']['theme'] = $theme;
                            }
                            $form['children'][0]['children'][] = $cap;
                            break;
                        case 'calendar':
                            mt_srand();
                            $cal = '{"attributes": {"class": "bfQuickModeElementClass", "id": "bfQuickMode'.mt_rand(0,mt_getrandmax()).'", "mdata": "{\"deletable\": true, \"type\": \"element\"}"}, "data": {"title": "untitled element", "icon": "../administrator/components/com_breezingforms/libraries/jquery/themes/quickmode/i/icon_calendar.png"}, "properties": {"type": "element", "bfType": "bfCalendar", "label": "untitled element", "labelPosition": "left", "bfName": "mycalendar", "dbId": 0, "orderNumber": -1, "tabIndex": -1, "logging": true, "hideLabel": false, "required": false, "hint": "", "off": false, "readonly": false, "format": "y-mm-dd", "value": "...", "size": "", "validationCondition": 0, "validationId": 0, "validationCode": "", "validationMessage": "", "validationFunctionName": "", "initCondition": 0, "initId": 0, "initCode": "", "initFunctionName": "", "initFormEntry": 0, "initPageEntry": 0, "actionCondition": 0, "actionId": 0, "actionCode": "", "actionFunctionName": "", "actionClick": 0, "actionBlur": 0, "actionChange": 0, "actionFocus": 0, "actionSelect": 0, "hideInMailback": false}}';
                            $cal = Zend_Json::decode($cal);
                            foreach($element As $prop){
                                switch($prop['PropertyName']){
                                    case 'NAME':
                                        $cal['properties']['bfName'] = preg_replace("/[^a-zA-Z0-9_]/", "", $prop['PropertyValue']);
                                        break;
                                    case 'CAPTION':
                                        $cal['data']['title']       = $prop['PropertyValue'];
                                        $cal['properties']['label'] = $prop['PropertyValue'];
                                        break;
                                    case 'DESCRIPTION':
                                        $cal['properties']['hint'] = $prop['PropertyValue'];
                                        break;
                                    case 'REQUIRED':
                                        $cal['properties']['required'] = $prop['PropertyValue'] == 'YES' ? true : false;
                                        $cal['properties']['validationId'] = $this->getValidationId('ff_valuenotempty');
                                        $cal['properties']['validationCondition'] = 1;
                                        $cal['properties']['validationFunctionName'] = 'ff_valuenotempty';
                                        break;
                                    case 'VALIDATIONMESSAGE':
                                        $cal['properties']['validationMessage'] = $prop['PropertyValue'];
                                        break;
                                    case 'POPUPLABEL':
                                        $cal['properties']['value'] = $prop['PropertyValue'];
                                        break;
                                    case 'ADDITIONALATTRIBUTES':
                                        $log .= trim($prop['PropertyValue']) != '' ? '- Use of additional attributes detected "'.htmlentities($prop['PropertyValue'],ENT_QUOTES,'UTF-8').'". You might need to adjust in BreezingForms if you use Javascript there.'."\n<br/>\n" : '';
                                        break;
                                }
                            }
                            $form['children'][0]['children'][] = $cal;
                            $log .= 'Calendar item detected, you might need to adjust the date format in BreezingForms.'."\n<br/>\n";
                            break;
                        case 'freeText':
                            mt_srand();
                            $section = '{"attributes": {"class": "bfQuickModeSectionClass", "id": "bfQuickModeSection'.mt_rand(0,mt_getrandmax()).'", "mdata": "{\"deletable\": true, \"type\": \"section\"}"}, "properties": {"bfType": "normal", "type": "section", "displayType": "breaks", "title": "untitled section", "name": "mysection", "description": "", "off": false}, "state": "open", "data": {"title": "untitled section", "icon": "../administrator/components/com_breezingforms/libraries/jquery/themes/quickmode/i/icon_section.png"}, "children": []}';
                            $section = Zend_Json::decode($section);
                            foreach($element As $prop){
                                switch($prop['PropertyName']){
                                    case 'NAME':
                                        $section['properties']['bfName'] = preg_replace("/[^a-zA-Z0-9_]/", "", $prop['PropertyValue']);
                                        break;
                                    case 'TEXT':
                                        $section['properties']['description'] = $prop['PropertyValue'];
                                        break;
                                }
                            }
                            $form['children'][0]['children'][] = $section;
                            break;
                        case 'fileUpload':
                            mt_srand();
                            $file = '{"attributes": {"class": "bfQuickModeElementClass", "id": "bfQuickMode'.mt_rand(0,mt_getrandmax()).'", "mdata": "{\"deletable\": true, \"type\": \"element\"}"}, "data": {"title": "untitled element", "icon": "../administrator/components/com_breezingforms/libraries/jquery/themes/quickmode/i/icon_file.png"}, "properties": {"type": "element", "bfType": "bfFile", "label": "untitled element", "labelPosition": "left", "bfName": "myfileupload", "dbId": 0, "orderNumber": -1, "tabIndex": -1, "logging": true, "hideLabel": false, "required": false, "hint": "", "off": false, "readonly": false, "uploadDirectory": "{ff_uploads}", "timestamp": false, "allowedFileExtensions": "zip,rar,pdf,doc,xls,ppt,jpg,jpeg,gif,png", "attachToUserMail": false, "attachToAdminMail": false, "flashUploader": false, "flashUploaderMulti": false, "flashUploaderBytes": 0, "flashUploaderTransparent": true, "flashUploaderWidth": 64, "flashUploaderHeight": 64, "useUrl": false, "useUrlDownloadDirectory": "", "validationCondition": 0, "validationId": 0, "validationCode": "", "validationMessage": "", "validationFunctionName": "", "initCondition": 0, "initId": 0, "initCode": "", "initFunctionName": "", "initFormEntry": 0, "initPageEntry": 0, "actionCondition": 0, "actionId": 0, "actionCode": "", "actionFunctionName": "", "actionClick": 0, "actionBlur": 0, "actionChange": 0, "actionFocus": 0, "actionSelect": 0, "hideInMailback": false}}';
                            $file = Zend_Json::decode($file);
                            foreach($element As $prop){
                                switch($prop['PropertyName']){
                                    case 'NAME':
                                        $file['properties']['bfName'] = preg_replace("/[^a-zA-Z0-9_]/", "", $prop['PropertyValue']);
                                        break;
                                    case 'CAPTION':
                                        $file['data']['title']       = $prop['PropertyValue'];
                                        $file['properties']['label'] = $prop['PropertyValue'];
                                        break;
                                    case 'DESCRIPTION':
                                        $file['properties']['hint'] = $prop['PropertyValue'];
                                        break;
                                    case 'REQUIRED':
                                        $file['properties']['required'] = $prop['PropertyValue'] == 'YES' ? true : false;
                                        $file['properties']['validationId'] = $this->getValidationId('ff_valuenotempty');
                                        $file['properties']['validationCondition'] = 1;
                                        $file['properties']['validationFunctionName'] = 'ff_valuenotempty';
                                        break;
                                    case 'VALIDATIONMESSAGE':
                                        $text['properties']['validationMessage'] = $prop['PropertyValue'];
                                        break;
                                    case 'ATTACHUSEREMAIL':
                                        $file['properties']['attachToUserMail'] = $prop['PropertyValue'] == 'YES' ? true : false;
                                        break;
                                    case 'ATTACHADMINEMAIL':
                                        $file['properties']['attachToAdminMail'] = $prop['PropertyValue'] == 'YES' ? true : false;
                                        break;
                                    case 'ACCEPTEDFILES':
                                        $accepted = str_replace(array("\n","\r"),array(",",""),$prop['PropertyValue']);
                                        $file['properties']['allowedFileExtensions'] = $accepted;
                                        break;
                                    case 'FILESIZE':
                                        $text['properties']['flashUploaderBytes'] = intval($prop['PropertyValue'])*8;
                                        break;
                                    case 'ADDITIONALATTRIBUTES':
                                        $log .= trim($prop['PropertyValue']) != '' ? '- Use of additional attributes detected "'.htmlentities($prop['PropertyValue'],ENT_QUOTES,'UTF-8').'". You might need to adjust in BreezingForms if you use Javascript there.'."\n<br/>\n" : '';
                                        break;
                                }
                            }
                            $form['children'][0]['children'][] = $file;
                            break;
                        case 'submitButton':
                            foreach($element As $prop){
                                switch($prop['PropertyName']){
                                    case 'LABEL':
                                        $form['properties']['submitLabel'] = $prop['PropertyValue'];
                                        break;
                                    case 'RESET':
                                        $form['properties']['cancelInclude'] = $prop['PropertyValue'] == 'YES' ? true : false;
                                        break;
                                    case 'RESETLABEL':
                                        $form['properties']['cancelLabel'] = $prop['PropertyValue'];
                                        break;
                                }
                            }
                            break;
                        case 'button':
                        case 'imageButton':
                            $reset = false;
                            $resetLabel = '';
                            $resetImage = '';
                            mt_srand();
                            $button = '{"attributes": {"class": "bfQuickModeElementClass", "id": "bfQuickMode'.mt_rand(0,mt_getrandmax()).'", "mdata": "{\"deletable\": true, \"type\": \"element\"}"}, "data": {"title": "untitled element", "icon": "../administrator/components/com_breezingforms/libraries/jquery/themes/quickmode/i/icon_submit-button.png"}, "properties": {"type": "element", "bfType": "bfSubmitButton", "label": "untitled element", "labelPosition": "left", "bfName": "mybutton", "dbId": 0, "orderNumber": -1, "tabIndex": -1, "logging": false, "hideLabel": true, "required": false, "hint": "", "off": false, "readonly": false, "value": "", "src": "", "validationCondition": 0, "validationId": 0, "validationCode": "", "validationMessage": "", "validationFunctionName": "", "initCondition": 0, "initId": 0, "initCode": "", "initFunctionName": "", "initFormEntry": 0, "initPageEntry": 0, "actionCondition": 0, "actionId": 0, "actionCode": "", "actionFunctionName": "", "actionClick": 0, "actionBlur": 0, "actionChange": 0, "actionFocus": 0, "actionSelect": 0, "hideInMailback": false}}';
                            $button = Zend_Json::decode($button);
                            foreach($element As $prop){
                                switch($prop['PropertyName']){
                                    case 'NAME':
                                        $button['properties']['bfName'] = preg_replace("/[^a-zA-Z0-9_]/", "", $prop['PropertyValue']);
                                        break;
                                    case 'CAPTION':
                                        $button['data']['title']       = $prop['PropertyValue'];
                                        $button['properties']['label'] = $prop['PropertyValue'];
                                        $button['properties']['value'] = $prop['PropertyValue'];
                                        break;
                                    case 'DESCRIPTION':
                                        $button['properties']['hint'] = $prop['PropertyValue'];
                                        break;
                                    case 'RESET':
                                        $reset = $prop['PropertyValue'] == 'YES' ? true : false;
                                        break;
                                    case 'RESETLABEL':
                                        $resetLabel = $prop['PropertyValue'];
                                        break;
                                    case 'IMAGEBUTTON':
                                        $button['properties']['src'] = $prop['PropertyValue'];
                                        break;
                                    case 'IMAGERESET':
                                        $resetImage = $prop['PropertyValue'];
                                        break;
                                    case 'ADDITIONALATTRIBUTES':
                                        $log .= trim($prop['PropertyValue']) != '' ? '- Use of additional attributes detected "'.htmlentities($prop['PropertyValue'],ENT_QUOTES,'UTF-8').'". You might need to adjust in BreezingForms if you use Javascript there.'."\n<br/>\n" : '';
                                        break;
                                }
                            }
                            $form['children'][0]['children'][] = $button;
                            // RESET
                            if($reset){
                                mt_srand();
                                $button = '{"attributes": {"class": "bfQuickModeElementClass", "id": "bfQuickMode'.mt_rand(0,mt_getrandmax()).'", "mdata": "{\"deletable\": true, \"type\": \"element\"}"}, "data": {"title": "untitled element", "icon": "../administrator/components/com_breezingforms/libraries/jquery/themes/quickmode/i/icon_submit-button.png"}, "properties": {"type": "element", "bfType": "bfSubmitButton", "label": "untitled element", "labelPosition": "left", "bfName": "bfQuickMode2932673", "dbId": 0, "orderNumber": -1, "tabIndex": -1, "logging": false, "hideLabel": true, "required": false, "hint": "", "off": false, "readonly": false, "value": "", "src": "", "validationCondition": 0, "validationId": 0, "validationCode": "", "validationMessage": "", "validationFunctionName": "", "initCondition": 0, "initId": 0, "initCode": "", "initFunctionName": "", "initFormEntry": 0, "initPageEntry": 0, "actionCondition": 0, "actionId": 0, "actionCode": "", "actionFunctionName": "", "actionClick": 0, "actionBlur": 0, "actionChange": 0, "actionFocus": 0, "actionSelect": 0, "hideInMailback": false}}';
                                $button = Zend_Json::decode($button);
                                $button['properties']['actionId'] = $this->getValidationId('ff_resetForm');
                                $button['properties']['actionCondition'] = 1;
                                $button['properties']['actionClick'] = 1;
                                $button['properties']['actionFunctionName'] = 'ff_resetForm';
                                $button['properties']['src'] = $resetImage;
                                foreach($element As $prop){
                                    switch($prop['PropertyName']){
                                        case 'NAME':
                                            $button['properties']['bfName'] = preg_replace("/[^a-zA-Z0-9_]/", "", $prop['PropertyValue']).'_reset';
                                            break;
                                        case 'CAPTION':
                                            $button['data']['title']       = $resetLabel;
                                            $button['properties']['label'] = $resetLabel;
                                            $button['properties']['value'] = $resetLabel;
                                            break;
                                    }
                                }
                                $form['children'][0]['children'][] = $button;
                            }
                            break;
                        case 'selectList':
                        case 'checkboxGroup':
                        case 'radioGroup':
                            mt_srand();
                            $select = '{"attributes": {"class": "bfQuickModeElementClass", "id": "bfQuickMode'.mt_rand(0,mt_getrandmax()).'", "mdata": "{\"deletable\": true, \"type\": \"element\"}"}, "data": {"title": "untitled element", "icon": "../administrator/components/com_breezingforms/libraries/jquery/themes/quickmode/i/icon_select.png"}, "properties": {"type": "element", "bfType": "bfSelect", "label": "untitled element", "labelPosition": "left", "bfName": "myselectlist", "dbId": 0, "orderNumber": -1, "tabIndex": -1, "logging": true, "hideLabel": false, "required": false, "hint": "", "off": false, "list": "0;Title 1;value1\n0;Title 2;value2\n0;Title 3;value3", "readonly": false, "multiple": false, "mailback": false, "width": "", "height": "", "validationCondition": 0, "validationId": 0, "validationCode": "", "validationMessage": "", "validationFunctionName": "", "initCondition": 0, "initId": 0, "initCode": "", "initFunctionName": "", "initFormEntry": 0, "initPageEntry": 0, "actionCondition": 0, "actionId": 0, "actionCode": "", "actionFunctionName": "", "actionClick": 0, "actionBlur": 0, "actionChange": 0, "actionFocus": 0, "actionSelect": 0, "hideInMailback": false}}';
                            if($element[0]['ComponentTypeName'] == 'checkboxGroup'){
                                $select = '{"attributes": {"class": "bfQuickModeElementClass", "id": "bfQuickMode'.mt_rand(0,mt_getrandmax()).'", "mdata": "{\"deletable\": true, \"type\": \"element\"}"}, "data": {"title": "untitled element", "icon": "../administrator/components/com_breezingforms/libraries/jquery/themes/quickmode/i/icon_check-box.png"}, "properties": {"type": "element", "bfType": "bfCheckboxGroup", "label": "untitled element", "labelPosition": "left", "bfName": "mycheckboxgroup", "dbId": 0, "orderNumber": -1, "tabIndex": -1, "logging": true, "hideLabel": false, "required": false, "hint": "", "off": false, "group": "0;Title 1;value1\n0;Title 2;value2\n0;Title 3;value3", "readonly": false, "wrap": false, "mailback": 1, "validationCondition": 0, "validationId": 0, "validationCode": "", "validationMessage": "", "validationFunctionName": "", "initCondition": 0, "initId": 0, "initCode": "", "initFunctionName": "", "initFormEntry": 0, "initPageEntry": 0, "actionCondition": 0, "actionId": 0, "actionCode": "", "actionFunctionName": "", "actionClick": 0, "actionBlur": 0, "actionChange": 0, "actionFocus": 0, "actionSelect": 0, "hideInMailback": false}}';
                            }
                            else if($element[0]['ComponentTypeName'] == 'radioGroup')
                            {
                                $select = '{"attributes": {"class": "bfQuickModeElementClass", "id": "bfQuickMode'.mt_rand(0,mt_getrandmax()).'", "mdata": "{\"deletable\": true, \"type\": \"element\"}"}, "data": {"title": "untitled element", "icon": "../administrator/components/com_breezingforms/libraries/jquery/themes/quickmode/i/icon_radio.png"}, "properties": {"type": "element", "bfType": "bfRadioGroup", "label": "untitled element", "labelPosition": "left", "bfName": "myradiogroup", "dbId": 0, "orderNumber": -1, "tabIndex": -1, "logging": true, "hideLabel": false, "required": false, "hint": "", "off": false, "group": "1;Yes;yes\n0;No;no", "readonly": false, "wrap": false, "validationCondition": 0, "validationId": 0, "validationCode": "", "validationMessage": "", "validationFunctionName": "", "initCondition": 0, "initId": 0, "initCode": "", "initFunctionName": "", "initFormEntry": 0, "initPageEntry": 0, "actionCondition": 0, "actionId": 0, "actionCode": "", "actionFunctionName": "", "actionClick": 0, "actionBlur": 0, "actionChange": 0, "actionFocus": 0, "actionSelect": 0, "hideInMailback": false}}';
                            }
                            $select = Zend_Json::decode($select);
                            foreach($element As $prop){
                                switch($prop['PropertyName']){
                                    case 'NAME':
                                        $select['properties']['bfName'] = preg_replace("/[^a-zA-Z0-9_]/", "", $prop['PropertyValue']);
                                        break;
                                    case 'CAPTION':
                                        $select['data']['title']       = $prop['PropertyValue'];
                                        $select['properties']['label'] = $prop['PropertyValue'];
                                        break;
                                    case 'DESCRIPTION':
                                        $select['properties']['hint'] = $prop['PropertyValue'];
                                        break;
                                    case 'VALIDATIONMESSAGE':
                                        $select['properties']['validationMessage'] = $prop['PropertyValue'];
                                        break;
                                    case 'MULTIPLE':
                                        $select['properties']['multiple'] = $prop['PropertyValue'] == 'YES' ? true : false;
                                        break;
                                    case 'REQUIRED':
                                        $select['properties']['required'] = $prop['PropertyValue'] == 'YES' ? true : false;
                                        if($select['properties']['required'] && $element[0]['ComponentTypeName'] == 'selectList'){
                                            $select['properties']['validationId'] = $this->getValidationId('ff_valuenotempty');
                                            $select['properties']['validationCondition'] = 1;
                                            $select['properties']['validationFunctionName'] = 'ff_valuenotempty';
                                        } else if($select['properties']['required']){
                                            $select['properties']['validationId'] = $this->getValidationId('ff_anychecked');
                                            $select['properties']['validationCondition'] = 1;
                                            $select['properties']['validationFunctionName'] = 'ff_anychecked';
                                        }
                                        break;
                                    case 'FLOW':
                                        $select['properties']['wrap'] = $prop['PropertyValue'] == 'HORIZONTAL' ? false : true;
                                        break;
                                    case 'ITEMS':
                                        if(strpos(trim($prop['PropertyValue']), '//<code>') === 0){
                                            $select['properties']['list'] = str_replace(array('//<code>','//</code>'),array('<?php ',' ?>'),$prop['PropertyValue']);
                                            $log .= '- Items code recognized for element "'.$select['properties']['bfName'].'", you will probably need to adjust it in BreezingForms'."\n<br/>\n";
                                        }else{
                                            $sel = '';
                                            $items = explode("\n",str_replace("\r","",$prop['PropertyValue']));
                                            foreach($items As $item){
                                                // test if advanced exists
                                                $value = '';
                                                $label = '';
                                                $advanced = explode("|", $item);
                                                if(count($advanced) == 2){
                                                    $label = $advanced[1];
                                                }else{
                                                    $label = $advanced[0];
                                                }
                                                $value = $advanced[0];
                                                // test if is selected
                                                $selected = count(explode("[c]",$label)) == 2 ? 1 : 0;
                                                $sel .= $selected . ';' . str_replace('[c]','',$label) . ';' . str_replace('[c]','',$value) . "\n";
                                            }
                                            $sel = trim($sel);
                                            if($element[0]['ComponentTypeName'] == 'checkboxGroup' || $element[0]['ComponentTypeName'] == 'radioGroup'){
                                                $select['properties']['group'] = $sel;
                                            } else {
                                                $select['properties']['list'] = $sel;
                                            }
                                        }
                                        break;
                                    case 'ADDITIONALATTRIBUTES':
                                        $log .= trim($prop['PropertyValue']) != '' ? '- Use of additional attributes detected "'.htmlentities($prop['PropertyValue'],ENT_QUOTES,'UTF-8').'". You might need to adjust in BreezingForms if you use Javascript there.'."\n<br/>\n" : '';
                                        break;
                                }
                            }
                            $form['children'][0]['children'][] = $select;
                            break;

                    }
                }
            }

            $quickMode = new QuickMode();
            $formId = $quickMode->save(
			0,
			$form
		);

            $returnCode = '';
            if($formId && isset($head['ReturnUrl']) && trim($head['ReturnUrl']) != ''){
                $returnCode = 'header("Location: '.trim($head['ReturnUrl']).'");'."\n".'exit;';
                $this->_db->setQuery("Update #__facileforms_forms Set `piece4cond` = 2, `piece4code` = ".$this->_db->Quote($returnCode)." Where id = " . $formId);
                $this->_db->query();
            }

            // User defined mail data is preferered over admin data

            if($formId && isset($head['AdminEmailSubject']) && trim($head['AdminEmailSubject'])){
               $this->_db->setQuery("Update #__facileforms_forms Set `custom_mail_subject` = ".$this->_db->Quote(str_replace(':value}','}',trim($head['AdminEmailSubject'])))." Where id = " . $formId);
               $this->_db->query();
            }
            
            if($formId && isset($head['UserEmailSubject']) && trim($head['UserEmailSubject'])){
               $this->_db->setQuery("Update #__facileforms_forms Set `custom_mail_subject` = ".$this->_db->Quote(str_replace(':value}','}',trim($head['UserEmailSubject'])))." Where id = " . $formId);
               $this->_db->query();
            }

            if(trim($head['AdminEmailReplyTo'])){
                $tables = JFactory::getDBO()->getTableFields( JFactory::getDBO()->getTableList() );
                if(isset($tables[JFactory::getDBO()->getPrefix().'facileforms_forms'])){
                    if(isset( $tables[JFactory::getDBO()->getPrefix().'facileforms_forms']['alt_mailfrom'] )){
                        $this->_db->setQuery("Update #__facileforms_forms Set `alt_mailfrom` = ".$this->_db->Quote(trim($head['AdminEmailReplyTo']))." Where id = " . $formId);
                        $this->_db->query();
                    }
                    if(!isset( $tables[JFactory::getDBO()->getPrefix().'facileforms_forms']['alt_fromname'] )){
                        $this->_db->setQuery("Update #__facileforms_forms Set `alt_fromname` = ".$this->_db->Quote(trim($head['AdminEmailFromName']))." Where id = " . $formId);
                        $this->_db->query();
                    }
                }
            }

            if(trim($head['AdminEmailFrom'])){
                $tables = JFactory::getDBO()->getTableFields( JFactory::getDBO()->getTableList() );
                if(isset($tables[JFactory::getDBO()->getPrefix().'facileforms_forms'])){
                    if(isset( $tables[JFactory::getDBO()->getPrefix().'facileforms_forms']['alt_mailfrom'] )){
                        $this->_db->setQuery("Update #__facileforms_forms Set `alt_mailfrom` = ".$this->_db->Quote(trim($head['AdminEmailFrom']))." Where id = " . $formId);
                        $this->_db->query();
                    }
                    if(!isset( $tables[JFactory::getDBO()->getPrefix().'facileforms_forms']['alt_fromname'] )){
                        $this->_db->setQuery("Update #__facileforms_forms Set `alt_fromname` = ".$this->_db->Quote(trim($head['AdminEmailFromName']))." Where id = " . $formId);
                        $this->_db->query();
                    }
                }
            }

            if(trim($head['UserEmailReplyTo'])){
                $tables = JFactory::getDBO()->getTableFields( JFactory::getDBO()->getTableList() );
                if(isset($tables[JFactory::getDBO()->getPrefix().'facileforms_forms'])){
                    if(isset( $tables[JFactory::getDBO()->getPrefix().'facileforms_forms']['alt_mailfrom'] )){
                        $this->_db->setQuery("Update #__facileforms_forms Set `alt_mailfrom` = ".$this->_db->Quote(trim($head['UserEmailReplyTo']))." Where id = " . $formId);
                        $this->_db->query();
                    }
                    if(isset( $tables[JFactory::getDBO()->getPrefix().'facileforms_forms']['alt_fromname'] )){
                        $this->_db->setQuery("Update #__facileforms_forms Set `alt_fromname` = ".$this->_db->Quote(trim($head['UserEmailFromName']))." Where id = " . $formId);
                        $this->_db->query();
                    }
                }
            }

            if(trim($head['UserEmailFrom'])){
                $tables = JFactory::getDBO()->getTableFields( JFactory::getDBO()->getTableList() );
                if(isset($tables[JFactory::getDBO()->getPrefix().'facileforms_forms'])){
                    if(isset( $tables[JFactory::getDBO()->getPrefix().'facileforms_forms']['alt_mailfrom'] )){
                        $this->_db->setQuery("Update #__facileforms_forms Set `alt_mailfrom` = ".$this->_db->Quote(trim($head['UserEmailFrom']))." Where id = " . $formId);
                        $this->_db->query();
                    }
                    if(isset( $tables[JFactory::getDBO()->getPrefix().'facileforms_forms']['alt_fromname'] )){
                        $this->_db->setQuery("Update #__facileforms_forms Set `alt_fromname` = ".$this->_db->Quote(trim($head['UserEmailFromName']))." Where id = " . $formId);
                        $this->_db->query();
                    }
                }
            }

            // scripts 2 pieces
            $beforeForm = '';
            if(trim($head['ScriptDisplay'])){
                $beforeForm = trim($head['ScriptDisplay']);
                $log .= '- Form Display Script detected, you might need to adjust it in BreezingForm\'s "Before Form Piece" in the form properties'."\n<br/>\n";
            }

            $beforeSubmit = '';
            if(trim($head['ScriptProcess'])){
                $beforeSubmit = trim($head['ScriptProcess']);
                $log .= '- Form Process Script detected, you might need to adjust it in BreezingForm\'s "Before Submit Piece" in the form properties'."\n<br/>\n";
            }

            $afterSubmit = '';
            if(trim($head['ScriptProcess2'])){
                $afterSubmit = trim($head['ScriptProcess2']);
                $log .= '- Form After Process Script detected, you might need to adjust it in BreezingForm\'s "After Submit Piece" in the form properties'."\n<br/>\n";
            }

            if($formId){
                $this->_db->setQuery("Update #__facileforms_forms Set `piece1cond` = ".($beforeForm != '' ? 2 : 0).", `piece1code` = ".$this->_db->Quote($beforeForm).", `piece3cond` = ".($beforeSubmit != '' ? 2 : 0).", `piece3code` = ".$this->_db->Quote($beforeSubmit).", `piece4cond` = ".($returnCode != '' || $afterSubmit != '' ? 2 : 0).", `piece4code` = ".$this->_db->Quote($afterSubmit . "\n" . $returnCode)." Where id = " . $formId);
                $this->_db->query();
            }

            $log .= '-------------------------------'."\n<br/><br/>\n";

            if($formId){
                $this->_db->setQuery("Insert Into #__rsformpro2breezingforms_import (rsformid,bfformid) Values (" . $cid . ",$formId)");
                $this->_db->query();
            }
            
            break;
        }

        $log .= 'Import Finished! If there are no hints, then your forms might work out of the box or need some adjustments as described above.';
        $log .= "\n<br/><br/>\n".'<a href="#" onclick="window.print();">Print Log</a>'."\n<br/><br/>\n";
        $log .= '<a href="index.php?option=com_rsformprotobreezingformsconverter">Back to the forms list</a>';

        return $log;
    }

    private function getValidationId($validationName){
        $this->_db->setQuery("Select id From #__facileforms_scripts Where `name` = " . $this->_db->Quote($validationName));
        $res = $this->_db->loadResult();
        $ret = $res ? $res : 0;
        return $ret;
    }

    /**
    * Gets the news
    * @return string The extension's news
    */
    private function _buildQuery(){

        return 'Select SQL_CALC_FOUND_ROWS * From #__rsform_forms Order By `FormName`';
    }

    function getData()
    {
        // Lets load the data if it doesn't already exist
        if (empty( $this->_data ))
        {
            $query = $this->_buildQuery();
            $this->_data = $this->_getList( $query, $this->getState('limitstart'), $this->getState('limit') );
        }

        return $this->_data;
    }

    function getTotal() {
        // Load the content if it doesn't already exist
        if (empty($this->_total)) {
            $query = $this->_buildQuery();
            $this->_total = $this->_getListCount($query);
        }
        return $this->_total;
    }

    function getPagination() {
        // Load the content if it doesn't already exist
        if (empty($this->_pagination)) {
            jimport('joomla.html.pagination');
            $this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
        }
        return $this->_pagination;
    }
}
